<?php

//
// Ce fichier ne sera execute qu'une fois
if (defined("_INC_CALCUL_SQUEL")) return;
define("_INC_CALCUL_SQUEL", "1");

include_local("inc-bcl-squel.php3");
include_local("inc-arg-squel.php3");
include_local("inc-reqsql-squel.php3");
include_local("inc-champ-squel.php3");
include_local("inc-index-squel.php3");
include_local("inc-parse-squel.php3");
include_local("inc-text-squel.php3");

function calculer_boucle($id_boucle, $boucles)
{
  global $table_primary, $table_des_tables; 

	$boucle = &$boucles[$id_boucle];
	$type_boucle = $boucle->type_requete;

 	list($return,$corps) = $boucle->return;

	// Boucle recursive : simplement appeler la boucle interieure

	if ($type_boucle == 'boucle')
	  {
	    return ("$corps\n\treturn  $return;");
	}

	$lang_select = ($boucle->lang_select != "non") &&
		($type_boucle == 'articles' OR $type_boucle == 'rubriques'
		OR $type_boucle == 'hierarchie' OR $type_boucle == 'breves');
	
	$flag_h = ($type_boucle == 'hierarchie');
	$flag_parties = ($boucle->partie AND $boucle->total_parties);
	$flag_cpt = $flag_parties || # pas '$compteur'  cause du cas 0
	  		strpos($corps,'compteur_boucle') ||
	  		strpos($return,'compteur_boucle');
	$primary_key = $table_primary[$type_boucle];

	if ($primary_key) // sinon c'est une boucle hors Spip
	  {
	    // invalidation des caches si la boucle n'est pas vide
	    // et n'est pas sur forum, car les messages ne sont pas ditables
	    if (($return == "''") OR
		($type_boucle == 'forums'))
	      $invalide = '';
	    else
	      {$id_table = $table_des_tables[$type_boucle]; 
		$boucle->select[] = "$id_table.$primary_key";
		$invalide = '
		$Cache["' . $primary_key . '"][$PileRow[$SP]["'  .
		  $primary_key . '"]]=1;';
	      }
	  }
	$corps =
	  ((!$flag_cpt) ? "" : "\n\t\t\$compteur_boucle++;") .
	  ((!$flag_parties) ? "" : '
		if	($compteur_boucle >= $debut_boucle AND 
			 $compteur_boucle <= $fin_boucle) {') .
	  (((!$lang_select)||($return == "''")) ? "" : ('
		if ($x = $PileRow[$SP]["lang"]) $GLOBALS["spip_lang"] = $x;')) .
	  $invalide .
	  ((!$boucle->doublons) ? "" : 
	   ("\n\t\t\$doublons .= ','. \$PileRow[\$SP]['" .
	    $primary_key . "'];")).
	  $corps .
	  (($return == "''") ? "" :
	   ((!$boucle->separateur) ? 
	    ("\n\t\t" . '$t0 .= ' . $return . ";") :
	    ("\n\t\t" . '$t1 = ' . $return . ";\n\t\t" .
	     '$t0 .= (($t1 && $t0) ? \'' . $boucle->separateur .
	     "' : '') . \$t1;"))).
	  ((!$flag_parties) ? "" : "\t\t}\n");

	// Recherche : recuperer les hash a partir de la chaine de recherche

	if ($boucle->hash) {
		$texte =  '
		global $recherche, $hash_recherche;
		if (!$hash_recherche) $hash_recherche = requete_hash($recherche);';}
	else { $texte = ''; }

	if ($flag_h) {
	    $texte .= '
	$hierarchie = ' . ($boucle->tout ?  $boucle->tout : 
			   // sinon,  paramtre pass par include.
			   // mme code, mais  inexcutable  la compilation:
			   '(($PileRow[0]["id_article"] ||
	      $PileRow[0]["id_syndic"]) ?
	    $PileRow[0]["id_rubrique"] :
	    $PileRow[0]["id_parent"])') .
	      ';
	$h0 = "";
	while ($hierarchie) {';
	}

	return  ($texte . '
	$t0 = "' . calculer_requete(&$boucle) . '";
	if (!($result = @mysql_query($t0))) {
		include_local("inc-debug-squel.php3");
		return erreur_requete_boucle($t0, "' . 
		 $id_boucle . '", "'.
		 $type_boucle . '");
	}
	$t0 = "";
	$SP++;' .
		 (($flag_parties) ? 
		  calculer_parties($boucle->partie,
				   $boucle->mode_partie,
				   $boucle->total_parties) :
		  ((!$boucle->numrows) ? '' : '
	$PileNum[$SP] = @spip_num_rows($result);')) .
		 ((!$flag_cpt) ? '' : "\n\t\$compteur_boucle = 0;") .
		 ((!$corps) ? "" :
		  (
		   ((!$lang_select) ? "" : '
	$old_lang = $GLOBALS[\'spip_lang\'];') . '
	while ($PileRow[$SP] = @spip_fetch_array($result)) {' .
		((!$flag_h) ? "" : '
		 $hierarchie = $PileRow[$SP][id_parent];') .
		$corps .
		"\n\t}" .
		((!$lang_select) ? "" : '
	$GLOBALS["spip_lang"] = $old_lang;'))) . '
	@spip_free_result($result);' .
		 (!($flag_h) ? '
	return $t0;' : ('
	$h0 = $t0 .' .
		   ((!$boucle->separateur) ? "" :
		    ('(($h0 && $t0) ? \'' . $boucle->separateur . "' : '') .")) .
		   ' $h0;}
	return $h0;')));
}


// une grosse fonction pour un petit cas

function calculer_parties($partie, $mode_partie, $total_parties)
{
     return ('
	$fin_boucle = @spip_num_rows($result);' .
		 (($mode_partie == '/') ?
		  ('
	$debut_boucle = 1+floor(($fin_boucle * ' . 
		   ($partie - 1) .
		   ' + ' .
		   ($total_parties - 1) .
		   ')/' .
		   $total_parties .
		   ");\n\t" .
		   '$fin_boucle = floor(($fin_boucle * ' .
		   $partie .
		   ' + ' .
		   ($total_parties - 1) .
		   ')/' .
		   $total_parties .
		   ");") :
		  (($mode_partie == '+') ?
		   ('
	$debut_boucle = ' . $partie . ';
	$fin_boucle -= ' . 
		   $total_parties) :
		   ('
	$debut_boucle = $fin_boucle - ' . $partie . ';
	$fin_boucle -= ' . 
		    ($partie - $total_parties)) .
		   ';'))  . '
	$PileNum[$SP] = $fin_boucle - $debut_boucle + 1;');
}


// Generer le code PHP correspondant a une liste d'objets syntaxiques

function calculer_liste($tableau, $prefix, $id_boucle, $niv, $rec, $boucles, $id_mere)
{
	if (!$tableau) return array("''",'');
	$texte = '';
	$exp = "";
	$firstset = true;
	$t = '$t' . ($niv+1);
	reset($tableau);
	while (list(, $objet) = each($tableau)) {
	  if ($objet->type == 'texte') {
	    $c = calculer_texte($objet->texte, $id_boucle);
	    $exp .= (!$exp ? $c : (" .\n\t\t$c"));
	  } else {
	  if ($objet->type == 'include') {
	    $c = calculer_include($objet->fichier,$objet->params, $id_boucle, &$boucles);
	    $exp .= (!$exp ? $c : (" .\n\t\t$c"));
	  } else {
	    if ($objet->type ==  'boucle') {
		$nom = $objet->id_boucle;
		list($bc,$bm) = calculer_liste($objet->cond_avant, $prefix,
					       $objet->id_boucle, $niv+2,$rec, &$boucles, $id_mere);
		list($ac,$am) = calculer_liste($objet->cond_apres, $prefix,
					       $objet->id_boucle, $niv+2,$rec, &$boucles, $id_mere);
		list($oc,$om) = calculer_liste($objet->cond_altern, $prefix,
					       $objet->id_boucle, $niv+1,$rec, &$boucles, $id_mere);

	      // on transmet avec & pour viter la recopie
	      // et rcuprer les affectations (Total_boucles & Cache)
	      
	      $c = $prefix .
		ereg_replace("-","_", $nom) .
		'($SP, &$PileRow, &$PileNum, &$Cache, $DB' .
		(!($rec || ( $objet->type_requete ==  'boucle')) ? ", true" : ', $inidoublon') . ')';
	      $m = "";
	    } else {
		list($c,$m) = 
		  calculer_champ($objet->fonctions, 
				 $objet->nom_champ,
				 $id_boucle,
				 &$boucles,
				 $id_mere);
		list($bc,$bm) = calculer_liste($objet->cond_avant, $prefix, $id_boucle, $niv+2,false, &$boucles, $id_mere); 
	      	list($ac,$am) = calculer_liste($objet->cond_apres, $prefix, $id_boucle, $niv+2,false, &$boucles, $id_mere);
		$oc = "''";
		$om = "";
	    }
	    // traitement commun des champs et boucles.
	    // Produit:
	    // m ; if (Tniv+1 = v)
	    // { bm; Tniv+1 = $bc . Tniv+1; am; Tniv+1 .= $ac }
	    // else { om; $Tniv+1 = $oc }
	    // Tniv .= Tniv+1
	    // Optimisations si une au moins des 4 squences $*m  est vide

	    if ($m) {
	      // il faut achever le traitement de l'exp prcdente
	      if ($exp) {
		  $texte .= "\n\t\t\$t$niv " .
		    (($firstset) ? "=" : ".=") .
		    "$exp;$m" ;
		  $firstset = false;
		  $exp = "";
	      } else { $texte .= $m;}
	    }
	    if (!($bm || $am || $om)) {
	      // 3 squences vides: 'if' inutile
	      $a = (($bc == "''") ?  "" : "$bc .") .
		$t .
		(($ac == "''") ?  "" : " . $ac");
	      // s'il y a un avant ou un aprs ou un alternant, il faut '?'
	      if (($a != $t) || ($oc != "''"))
		$c = "(($t = $c) ? ($a) : ($oc))";
	      $exp .= (!$exp ? $c : (" .\n\t\t$c"));
	    } else {
	      // il faut achever le traitement de l'exp prcdente
	      if ($exp) {
		  $texte .= "\n\t\t\$t$niv " .
		    (($firstset) ? "=" : ".=") .
		    "$exp;$m" ;
		  $firstset = false;
		  $exp = "";
	      } else { $texte .= $m;}
	      $texte .= "\n\t\tif ($t = $c) {\n" . $bm;
	      $texte .= "\n\t\t$t = $bc . $t";
	      if (!$am) {
		$texte .= " . $ac";
	      } else $texte .= "; $am $t .=  $ac";
	      $texte .= ";}";
	      if (!$om)
		{ $texte .= " else {" . $om . "$t =  $oc;}"; }
	      $exp = $t;
	    }
	  }
	  }
	} // while
	if (!$exp) $exp ="''";
	return  (!$texte ? array ($exp, "") : 
		 array('$t'.$niv. ". $exp",$texte));
}


// Phraser le pseudo .html puis traduire en PHP

function calculer_squelette($squelette) {

  $boucles = '';
  $racine = parser(join(file("$squelette.html"), ""), '',&$boucles);

  $squelette_nom = ereg_replace("[^a-zA-Z0-9_]", "_", $squelette);
  $func = 'squelette_'.$squelette_nom.'_executer';
  $prefix = 'squelette_'.$squelette_nom.'_boucle';
  
  // calculer les corps des boucles PHP

  if ($boucles)
    {
      foreach($boucles as $id => $boucle)
	{ 
	  if ($boucle->type_requete == 'boucle')
	    {
	      $boucles[$id]->return =
		calculer_liste(array($boucles[$boucle->param]),
			       $prefix,
			       $boucle->param,
			       1,
			       true,
			       &$boucles,
			       $id);
	    }
	} 
      foreach($boucles as $id => $boucle)
	{ 
	  if ($boucle->type_requete != 'boucle') 
	    {
#	  spip_log("calcul_liste $id de type" . $boucle->type_requete);
	  calculer_params($boucle->type_requete, $boucle->param, $id, &$boucles);

	  $boucles[$id]->return =
	    calculer_liste($boucle->milieu,
			   $prefix,
			   $id,
			   1,
			   false,
			   &$boucles,
			   $id);
	    }
	}
    }

  // Calculer le code PHP de la racine

  list($return,$corps) =
    calculer_liste($racine, $prefix, '',0, false, &$boucles, '');

  // Corps de toutes les fonctions PHP,
  // en particulier les requetes SQL et TOTAL_BOUCLE
  // dterminables seulement maintenant

  $code = '';

  if ($boucles)
    {
      foreach($boucles as $id => $boucle)
	{
	  $boucles[$id]->return = calculer_boucle($id, &$boucles); 
	}
      
      foreach($boucles as $id => $boucle) 
	{
	  $code .= "\n\nfunction $prefix" . ereg_replace("-","_",$id) .
	"(\$SP, \$PileRow, \$PileNum, \$Cache, \$DB, \$inidoublon='') {" .
	    (!$boucle->doublons ? '' : '
		static $doublons; 
		if ($inidoublon) $doublons = "0";') . 
	    $boucle->return .
	    "\n}\n";
	}
    }
  $code .=
    "\nfunction $func(\$contexte, \$cache) {\n" . '
 $SP = 0;
 $PileRow[0] = $contexte;
 $Cache["cache"] = $cache;
 $DB = "";
 if ($GLOBALS["mysql_rappel_connexion"] AND $DB = $GLOBALS["spip_mysql_db"])
	$DB = "`$DB`";
 $DB .= $GLOBALS["table_prefix"];' .
    $corps . "\n \$t0 = " . $return . ';
 return (array($t0, $Cache));' .
    "\n}\n\n\$func_squelette_executer = '$func';\n" ;

  return $code;
}

?>
